//  Beispiel 14 "Berechnung von richtigen, nicht reprozierbaren Zufallszahlen"
//  
//  Unter Verwendung der IoT Brick Library

#include <all_IoT.h>

float a = 0.0, b = 3.0, Zeit = 0.0;
long Start = 0, Ende = 0, Groesse = 1;
long stat[256];

void setup()
{
  IoT_Init(true);
  IoT_TerminalWaitInit(true);      // Auf Terminalverbindung warten, damit nichts verloren geht
  IoT_WatchDog(false);
  Serial.println("");
  Serial.print(chr(12));
  Serial.println("Welcome to IoT Brick Random-Number-Generator" + spc(22) + "(c) 2015-2017");
  Serial.println(repeatstr("-", 79));
  Serial.println("");//....1....!....2....!....3....!....4....!....5....!....6....!....7....!....8
  Serial.println("Der Random-Number-Generator berechnet 65.536 richtige Zufallszahlen zwischen 0");
  Serial.println("und 255. Dabei wird die Häufigkeit, mit der jede der 256 möglichen Zahlen auf-");
  Serial.println("tritt, statistisch ausgewertet. Die Berechnung der Zufallszahlen bezieht dabei");
  Serial.println("den Microsekunden-Timer mit ein, wodurch bei jedem Programmstart immer neue,");
  Serial.println("nicht reprozierbare Zufallszahlen entstehen. Statistische Verteilung:");
  Serial.println("");

  for (int i = 0; i <= 255; i++)
  {
    stat[i] = 0;
  }

  for (long i = 0; i <= 0xFFFF; i++)
  {
    byte r = rndbyte();
    stat[r] += 1;
    IoT_Idle();
  }

  for (int i = 0; i <= 255; i++)
  {
    Serial.print(hexword(stat[i]));
    if (i < 255)
    {
      Serial.print(" ");
    }
  }
}

void loop()
{
  IoT_ShutDown();
}

